--    ======================
--    Description
--    ======================
--
--    Logika sterująca zaworem mieszającym 0..10V.
--
--    Zawór mieszający 0..10V pracuje w zdefiniowanym zakresie 
--
--    Logika utrzymuje na zasilaniu stałą temperaturę 
--
--    ======================
--    Parameters
--    ======================
--
--    SubLogic supports following variables:
--
--    input.supply.t.value
--    input.supply.t.err                      - temperatura zasilania
--
--    input.boost                             - wyzwalacz funkcji boost. Jakakolwiek wartość <> 0 uruchamia funkcję boost.
--                                              Po rozpoczęciu funkcji boost wyzwalacz ma wartość 0.
--                                              Funkcja boost oznacza przypisaniu wyjściu wartości setting.boost.value.
--                                              Dalsza regulacja będzie następować od tej wartości.
--
--    output                                  - wyjściowa pozycja zaworu
--
--    setting.supply.demand.t.value           - wymagana temperatura na zasilaniu
--
--    setting.supply.t.hyst                   - histereza dla temperatury zasilania (w obrębie histerezy zawór nie zmienia pozycji)
--
--    setting.valve.position.max              - maksymalna wartość otwarcia zaworu
--
--    setting.valve.position.min              - minimalna wartość otwarcia zaworu
--
--    setting.valve.change.value              - wartość zmiany pozycji zaworu w każdym kroku
--
--    setting.valve.timer.idle                - czas bezczynności zaworu [s]
--
--    setting.alert.t.valve.position          - wartość zaworu w przypadku błędu temperatury
--
--    setting.boost.value                     - wartość wyjścia po uruchomieniu funkcji boost
--
--    counter.valve.idle.downcounter          - licznik czasu bezczynności [s]
--
--    counter.alert.t.state                   - jeżeli któryś z czujników jest uszkodzony to ta flaga jest ustawiana na 1. 
--                                              W takim przypadku zawór jest w pozycji setting.alert.t.valve.position [0..1]
--
--    Logic uses lua language to implement own behaviour
--
--    ======================
--    mandatory variables
--    ======================
--
--    Logic expects following mandatory variables:
--
--    reload.trigger                          - causes reloading lua script
--
--    memcnt                                  - current amount of memory used by lua in bytes
--
--    Logic expects following kv settings:
--
--    LuaScriptPath                           - path to the lua script - must be absolute
--
--    ======================
--    ChangeLog
--    ======================
--
--    2023-03-16 ver 1.1.1
--
--    + dodanie funkcji boost
--
--    2017-11-13 ver 0.0.0
--
--    # First release
--
-- user can use some functions provided by ibmanager.

-- ibmanager provides following functions to use:
--
-- function returns value of required ibmanager variable
-- @param fullName - string - variable name - name of variable of which value must be returned, for example "rs.0.id.255.input.t.0.value"
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getValue(fullName)


-- function set value of given ibmanager variable
-- @param fullName - string - variable name - name of variable of which value we want to set, for example "rs.0.id.255.input.t.0.value"
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setValue(fullName, value)


-- function returns value of required ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getLogicValue(key)


-- function set value of given ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setLogicValue(key, value)

-- function returns two sections of kvsettings from xml configuration file
-- returned value is two element table, each of these elements is table too.
-- indices of returned table are strings and equal "instance" and "global"
-- values of returned tables are tables and contain KVsettings for applicable section.
-- nested tables have form key = value, where key is index in nested table and value is value.
-- example: {"instance" = {"ikey1" = "ivalue1", "ikey2" = "gvalue2"}, "global" = {"gkey1" = "gvalue1", "gkey2" = "gvalue2", "gkey3" = "gvalue3"}}
-- @return          - two dimensional array - kvsettings for global and instance sections
-- getKvSettings()


-- function schedules alert to send.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- scheduleAlert(id)

-- function cancels alert sending, if was previously scheduled. if not then only wakes up alerts handling thread, so if there is no need to call this function, then do not call it.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- cancelAlert(name)

-- function returns table, containing Variables that belongs to required list.
-- @param listName - Name attribute of VarList, RemoteVarList or ImportVarList elemetnst in configurationfile
-- @return array of key-value pairs. Key - variable postfix, Value - Variable value
-- getVarList(listName)

-- function returns monotonic system clock value, that elapsed since specific epoch
-- returned time is expressed in milliseconds.
-- getClock()

-- function logs message to file, if defined in configuration file log level is less than passed to this function
-- @param logLevel - one of:
--        LogLevel.TraceLo
--        LogLevel.Trace
--        LogLevel.TraceHi
--        LogLevel.DebugLo
--        LogLevel.Debug
--        LogLevel.DebugHi
--        LogLevel.Info
--        LogLevel.Notice
--        LogLevel.Warning
--        LogLevel.Error
--        LogLevel.Critical
-- @param logMessage - string to log
-- log(logLevel, logMessage)


-- ibmanager provides following global variables:

-- logic type, (in this case it will always be "Lua") - the same as in logic configuration file in section: <Logic Type="Lua" ...
-- LOGIC_TYPE

-- logic version, the same as in logic configuration file in section: <Logic ... Version="x.y.z" ...
-- LOGIC_VERSION

-- logic sub-type, the same as in logic configuration file in section: <Logic ... SubType="Hysteresis" ...
-- LOGIC_SUBTYPE

-- logic sub-version, the same as in logic configuration file in section: <Logic ... SubVersion="x.y.z" ...
-- LOGIC_SUBVERSION

-- logic instance name - the same as in logic configuration file, in section: <Instance Name="0">
-- LOGIC_INSTANCE_NAME

-- add script directory to package path
package.path = package.path .. ";./logic/scripts/utils/?.lua";

-- use script - without .lua extension - delta class
require("State");
require("DownCounter");

g_output = nil;

g_counterValveTimerIdle = nil;

SUPPORTED_SUBLOGIC_TYPE = "MixValve02";
SUPPORTED_SUBLOGIC_VERSION = "1.1.1";
g_versionChecked = false;

-- entry point to the logic
-- @param firstCall - tells if logic is called first time
-- @return        - nothing
function onLogicCall(firstCall)

  if not g_versionChecked then
    -- checking sublogic type and sublogic version
    if LOGIC_SUBTYPE ~= SUPPORTED_SUBLOGIC_TYPE then
      error("Wrong logic sub-type. expected " .. SUPPORTED_SUBLOGIC_TYPE .. " but used " .. LOGIC_SUBTYPE);
    end
    local versionWithoutBuild = string.match(LOGIC_SUBVERSION, "[0-9]+%.[0-9]+%.[0-9]+");
    if versionWithoutBuild ~= SUPPORTED_SUBLOGIC_VERSION then
      error("Wrong logic sub-version. expected " .. SUPPORTED_SUBLOGIC_VERSION .. " but used " .. LOGIC_SUBVERSION);
    end
    g_versionChecked = true;
  end

  local inputSupplyTValue = getLogicValue("input.supply.t.value");
  local inputSupplyTErr = getLogicValue("input.supply.t.err");
  local settingSupplyDemandTValue = getLogicValue("setting.supply.demand.t.value");
  local settingSupplyTHyst = getLogicValue("setting.supply.t.hyst");
  local settingValvePositionMax = getLogicValue("setting.valve.position.max");
  local settingValvePositionMin = getLogicValue("setting.valve.position.min");
  local settingValveChangeValue = getLogicValue("setting.valve.change.value");
  local settingValveTimerIdle = getLogicValue("setting.valve.timer.idle");
  local settingAlertTValvePosition = getLogicValue("setting.alert.t.valve.position");
  local settingBoostValue = getLogicValue("setting.boost.value");

  local counterValveIdleDowncounter = 0;
  local counterAlertTState = 0;

  -- timers

  if g_counterValveTimerIdle == nil or firstCall then
    g_counterValveTimerIdle = DownCounter.create();
  end
  g_counterValveTimerIdle:updateParams(settingValveTimerIdle * 1000);

--  if g_counterValveTimerIdle:elapsed() then
--    g_counterValveTimerIdle:reset();
--  end

  counterValveIdleDowncounter = g_counterValveTimerIdle:timeTo0() / 1000;
  counterValveIdleDowncounter = (counterValveIdleDowncounter < 0) and 0 or counterValveIdleDowncounter;

  -- states
  if g_output == nil or firstCall then
    g_output = State.create(0, 0, 100, true);
  end
  g_output:call();

  -- obsługa alarmu temperatury
  if ((inputSupplyTErr ~= 0)) then
    counterAlertTState = 1;
    g_output:setValue(settingAlertTValvePosition);
  end

  -- obsługa funkcji boost
  if (getLogicValue("input.boost") ~= 0 ) then
    setLogicValue("input.boost", 0);

    if (settingBoostValue < settingValvePositionMin) then
      g_output:setValue(settingValvePositionMin);
    elseif (settingBoostValue > settingValvePositionMax) then
      g_output:setValue(settingValvePositionMax);
    else
      g_output:setValue(settingBoostValue);
    end
  end

  -- sterowanie zaworem
  if g_counterValveTimerIdle:elapsed() then
    if (inputSupplyTValue > settingSupplyDemandTValue + settingSupplyTHyst / 2) then
      -- przymknij
      if ((g_output:getValue() - settingValveChangeValue) < settingValvePositionMin) then
        g_output:setValue(settingValvePositionMin);
      else
        g_output:setValue(g_output:getValue() - settingValveChangeValue);
      end
    elseif (inputSupplyTValue < settingSupplyDemandTValue - settingSupplyTHyst / 2) then
      -- otwórz
      if ((g_output:getValue() + settingValveChangeValue) > settingValvePositionMax) then
        g_output:setValue(settingValvePositionMax);
      else
        g_output:setValue(g_output:getValue() + settingValveChangeValue);
      end
    else
      -- bez zmian
    end
    
    g_counterValveTimerIdle:reset();
  end  

  -- send logic variables to ibmanager
  setLogicValue("output", g_output:getValue());
  setLogicValue("counter.valve.idle.downcounter", counterValveIdleDowncounter);
  setLogicValue("counter.alert.t.state", counterAlertTState);

end
